<template>
  <h1>Создание нового задания</h1>
  <TabsBar>
    <AppTab
      v-for="tab in tabs"
      :key="tab.id"
      :to="tab.route"
      :showActive="tab.id === activeTab.id"
      :completed="tab.id < activeTab.id"
      @click="switchTab(tab.id)"
    >
      {{ tab.label }}
    </AppTab>
  </TabsBar>
  <TaskNavigation>
    <AppButton
      :theme="buttonThemes.light"
      :icon="buttonIcons.back"
      v-if="activeTab.id !== 1"
      @click="switchTab(activeTab.id - 1)"
    >
      Назад
    </AppButton>
    <AppButton
      :theme="buttonThemes.light"
      :icon="buttonIcons.next"
      v-if="activeTab.id !== 3"
      @click="switchTab(activeTab.id + 1)"
    >
      Далее
    </AppButton>
    <span class="vertical-separator"></span>
    <AppButton
      :theme="buttonThemes.light"
      :icon="buttonIcons.save"
      @click="saveTask()"
    >
      Сохранить
    </AppButton>
    <AppButton
      :theme="buttonThemes.light"
      :icon="buttonIcons.cancel"
      @click="AskForCloseTaskDetails"
    >
      Отмена
    </AppButton>
  </TaskNavigation>
  <router-view></router-view>
  <ModalDialog
    title="Отменить примененные действия ?"
    text="Измененные вами данные удалятся без возможности восстановления."
    :show="showDialog"
    :showCounter="false"
  >
    <template #actions>
      <AppButton :theme="buttonThemes.light" @click="cancelCancel">
        Отмена
      </AppButton>
      <AppButton :theme="buttonThemes.prime" @click="closeTaskDetails">
        Вернуться на главную
      </AppButton>
    </template>
  </ModalDialog>
  <ModalDialog
    title="Внимание"
    text="Поля 'Название' и 'Дата завершения' обязательны для заполнения"
    :show="showAlert"
    :showCounter="false"
  >
    <template #actions>
      <AppButton :theme="buttonThemes.prime" @click="closeAlertModal">
        Понятно
      </AppButton>
    </template>
  </ModalDialog>
</template>

<script>
import TabsBar from "@/components/TabsBar.vue";
import TaskNavigation from "@/components/TaskNavigation.vue";
import AppTab from "@/components/UI/AppTab.vue";
import AppButton, {
  themes as buttonThemes,
  icons as buttonIcons,
} from "@/components/UI/AppButton.vue";
import { mapState } from "vuex";
import ModalDialog from "@/components/ModalDialog.vue";
import store from "@/store";

export default {
  name: "TaskDetails",
  components: { ModalDialog, AppButton, TabsBar, TaskNavigation, AppTab },
  data() {
    const tabs = [
      {
        id: 1,
        label: "1. Основные настройки ",
        route: `step1`,
      },
      {
        id: 2,
        label: "2. Документы",
        route: `step2`,
      },
      {
        id: 3,
        label: "3. Комментарии",
        route: `step3`,
      },
    ];
    return {
      buttonThemes,
      buttonIcons,
      activeTab: tabs.find(
        (tab) => tab.route === this.$route.path.split("/").pop()
      ), // ID активной вкладки
      tabs,
      showDialog: false,
      showAlert: false,
    };
  },
  computed: {
    isEditStatus: {
      get: () => store.state.isEditMode,
      set: (val) => store.commit("changeEditMode", val),
    },
    ...mapState({ taskDetails: (state) => state.taskDetails }),
  },
  methods: {
    switchTab(id) {
      if (
        this.taskDetails.name.length > 1 &&
        this.taskDetails.deadline.length > 1
      ) {
        const tab = this.tabs.find((item) => item.id === id);
        if (tab) {
          this.$router.push(
            this.$route.path.replace(this.activeTab.route, tab.route)
          ); // Пушим новый роут
          this.activeTab = tab;
        }
      } else {
        this.showAlert = true;
      }
    },
    AskForCloseTaskDetails() {
      this.showDialog = true;
    },
    cancelCancel() {
      this.showDialog = false;
    },
    closeAlertModal() {
      this.showAlert = false;
    },
    closeTaskDetails() {
      this.$router.push("/");
      this.$store.commit("reset");
    },
    async saveTask() {
      if (
        this.taskDetails.name.length > 1 &&
        this.taskDetails.deadline.length > 1
      ) {
        await this.$store.dispatch("saveTask");
        this.$router.push("/");
      } else {
        this.showAlert = true;
      }
    },
  },
  mounted() {
    if (this.$route.path.split("/")[2] === "edit") {
      this.$store.dispatch("getTask", this.$route.path.split("/")[3]);
      this.$store.commit("changeEditMode", true);
    } else {
      if (
        this.taskDetails.name.length < 1 &&
        this.taskDetails.deadline.length < 1 &&
        this.$route.path.split("/").pop() !== "step1"
      ) {
        this.$router.push("/task/create/");
        this.activeTab = this.tabs[0];
      }
      this.$store.commit("changeEditMode", false);
    }
  },
};
</script>

<style></style>
